#include "engine-exports.h"
#include "scc-core.h"
#include "../system/supervisorinterface.h"
# line 89 "../../../../Macaulay2/d/engine.dd"

    #include <error.h>
    #include <exceptions.hpp>
    #include <newdelete.hpp>
    #include <hash.hpp>
    #include <monomial.hpp>
    #include <relem.hpp>
    #include <matrix.hpp>
    #include <mat.hpp>

# line 206 "../../../../Macaulay2/d/engine.dd"

  extern "C" void remove_monideal(void *, void *);
  struct MonomialIdeal;
  void intern_monideal(struct MonomialIdeal *);
  
# line 101 "../../../../Macaulay2/d/engine.dd"
M2_string engine_EngineError(M2_string d){
  # line 101 "../../../../Macaulay2/d/engine.dd"
  M2_string s;
  # line 101 "../../../../Macaulay2/d/engine.dd"
  M2_string tmp_;
  # line 101 "../../../../Macaulay2/d/engine.dd"
  s = M2_tostring(error_message());
  # line 102 "../../../../Macaulay2/d/engine.dd"
  if ((s->len == 0)) goto L0_;
  # line 102 "../../../../Macaulay2/d/engine.dd"
  tmp_ = s;
  # line 102 "../../../../Macaulay2/d/engine.dd"
  goto L1_;
  # line 102 "../../../../Macaulay2/d/engine.dd"
  L0_:;
  # line 102 "../../../../Macaulay2/d/engine.dd"
  tmp_ = d;
  # line 102 "../../../../Macaulay2/d/engine.dd"
  L1_:;
  # line 102 "../../../../Macaulay2/d/engine.dd"
  return tmp_;
  # line 102 "../../../../Macaulay2/d/engine.dd"
  }
# line 105 "../../../../Macaulay2/d/engine.dd"
engine_RawMonomialOrNull engine_star_(const struct Monomial * x,const struct Monomial * y){
  # line 105 "../../../../Macaulay2/d/engine.dd"
  
     try { return *x * *y; } catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 105 "../../../../Macaulay2/d/engine.dd"
  }
# line 107 "../../../../Macaulay2/d/engine.dd"
engine_RawMonomialOrNull engine_circ_(const struct Monomial * x,int n){
  # line 107 "../../../../Macaulay2/d/engine.dd"
  
     try { return x->power(n); } catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 107 "../../../../Macaulay2/d/engine.dd"
  }
# line 110 "../../../../Macaulay2/d/engine.dd"
engine_RawMonomialOrNull engine_slash_(const struct Monomial * x,const struct Monomial * y){
  # line 110 "../../../../Macaulay2/d/engine.dd"
  const struct Monomial * z;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  engine_RawMonomialOrNull tmp__1;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  engine_RawMonomialOrNull tmp__2;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  tmp__1 = engine_circ_(y, (- 1));
  # line 110 "../../../../Macaulay2/d/engine.dd"
  if (0 == tmp__1) goto L3_;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  goto L2_;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  L2_:;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  z = ((const struct Monomial *)tmp__1);
  # line 110 "../../../../Macaulay2/d/engine.dd"
  tmp__2 = engine_star_(x, z);
  # line 110 "../../../../Macaulay2/d/engine.dd"
  goto L4_;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  L3_:;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  tmp__2 = ((engine_RawMonomialOrNull)((void *)0));
  # line 110 "../../../../Macaulay2/d/engine.dd"
  goto L4_;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  L4_:;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  return tmp__2;
  # line 110 "../../../../Macaulay2/d/engine.dd"
  }
# line 112 "../../../../Macaulay2/d/engine.dd"
engine_RawRingElementOrNull engine_plus_(const struct RingElement * x,const struct RingElement * y){
  # line 112 "../../../../Macaulay2/d/engine.dd"
  
     try { return *x + *y; } catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 112 "../../../../Macaulay2/d/engine.dd"
  }
# line 114 "../../../../Macaulay2/d/engine.dd"
const struct RingElement * engine_minus_(const struct RingElement * y){
  # line 114 "../../../../Macaulay2/d/engine.dd"
  
     try { return -*y; } catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 114 "../../../../Macaulay2/d/engine.dd"
  }
# line 116 "../../../../Macaulay2/d/engine.dd"
engine_RawRingElementOrNull engine_minus__1(const struct RingElement * x,const struct RingElement * y){
  # line 116 "../../../../Macaulay2/d/engine.dd"
  
     try { return *x - *y; } catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 116 "../../../../Macaulay2/d/engine.dd"
  }
# line 118 "../../../../Macaulay2/d/engine.dd"
engine_RawRingElementOrNull engine_star__1(const struct RingElement * x,const struct RingElement * y){
  # line 118 "../../../../Macaulay2/d/engine.dd"
  
     try { return *x * *y; } 
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 118 "../../../../Macaulay2/d/engine.dd"
  }
# line 121 "../../../../Macaulay2/d/engine.dd"
engine_RawRingElementOrNull engine_slash_slash_(const struct RingElement * a,const struct RingElement * b){
  # line 121 "../../../../Macaulay2/d/engine.dd"
  
     try { const Ring *R = a->get_ring();
	   if (R != b->get_ring()) {
	       ERROR("ring division requires both elements to have the same base ring");
	       return 0; }
	   ring_elem result = R->quotient(a->get_value(), b->get_value());
	   if (error()) return 0;
	   return RingElement::make_raw(R, result);
     } catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 121 "../../../../Macaulay2/d/engine.dd"
  }
# line 130 "../../../../Macaulay2/d/engine.dd"
engine_RawRingElementOrNull engine_pct_(const struct RingElement * a,const struct RingElement * b){
  # line 130 "../../../../Macaulay2/d/engine.dd"
  
    try { const Ring *R = a->get_ring();
	  if (R != b->get_ring()) {
	      ERROR("ring remainder requires both elements to have the same base ring");
	      return 0; }
	  ring_elem result = R->remainder(a->get_value(), b->get_value());
	  if (error()) return 0;
	  return RingElement::make_raw(R, result); }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 130 "../../../../Macaulay2/d/engine.dd"
  }
# line 139 "../../../../Macaulay2/d/engine.dd"
engine_RawRingElementOrNull engine_circ__1(const struct RingElement * a,mpz_srcptr n){
  # line 139 "../../../../Macaulay2/d/engine.dd"
  
     try { RingElement *z = a->power(n); return error() ? NULL : z; }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 139 "../../../../Macaulay2/d/engine.dd"
  }
# line 142 "../../../../Macaulay2/d/engine.dd"
engine_RawMatrixOrNull engine_plus__1(const struct Matrix * M,const struct Matrix * N){
  # line 142 "../../../../Macaulay2/d/engine.dd"
  
     try { return *M + *N; }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 142 "../../../../Macaulay2/d/engine.dd"
  }
# line 150 "../../../../Macaulay2/d/engine.dd"
engine_RawMutableMatrixOrNull engine_plus__2(struct MutableMatrix * M,struct MutableMatrix * N){
  # line 150 "../../../../Macaulay2/d/engine.dd"
  
     return M->add(N);
     ;
  # line 150 "../../../../Macaulay2/d/engine.dd"
  }
# line 159 "../../../../Macaulay2/d/engine.dd"
engine_RawMatrixOrNull engine_minus__2(const struct Matrix * M){
  # line 159 "../../../../Macaulay2/d/engine.dd"
  
     try { return - *M; }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 159 "../../../../Macaulay2/d/engine.dd"
  }
# line 162 "../../../../Macaulay2/d/engine.dd"
struct MutableMatrix * engine_minus__3(struct MutableMatrix * M){
  # line 162 "../../../../Macaulay2/d/engine.dd"
  return M->negate();;
  # line 162 "../../../../Macaulay2/d/engine.dd"
  }
# line 163 "../../../../Macaulay2/d/engine.dd"
engine_RawMatrixOrNull engine_minus__4(const struct Matrix * M,const struct Matrix * N){
  # line 163 "../../../../Macaulay2/d/engine.dd"
  
     try { return *M - *N; }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 163 "../../../../Macaulay2/d/engine.dd"
  }
# line 171 "../../../../Macaulay2/d/engine.dd"
engine_RawMutableMatrixOrNull engine_minus__5(struct MutableMatrix * M,struct MutableMatrix * N){
  # line 171 "../../../../Macaulay2/d/engine.dd"
  
     try { return M->subtract(N); }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 171 "../../../../Macaulay2/d/engine.dd"
  }
# line 175 "../../../../Macaulay2/d/engine.dd"
engine_RawMatrixOrNull engine_star__2(const struct RingElement * f,const struct Matrix * M){
  # line 175 "../../../../Macaulay2/d/engine.dd"
  
     try { if (f->get_ring() != M->get_ring()) {
	       ERROR("ring element and matrix should have the same base ring");
	       return 0; }
	  return M->scalar_mult(f->get_value(), false); }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 175 "../../../../Macaulay2/d/engine.dd"
  }
# line 181 "../../../../Macaulay2/d/engine.dd"
engine_RawMatrixOrNull engine_star__3(const struct Matrix * M,const struct RingElement * f){
  # line 181 "../../../../Macaulay2/d/engine.dd"
  
     try { if (f->get_ring() != M->get_ring()) {
	       ERROR("ring element and matrix should have the same base ring");
	       return 0; }
	  return M->scalar_mult(f->get_value(), true); }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 181 "../../../../Macaulay2/d/engine.dd"
  }
# line 187 "../../../../Macaulay2/d/engine.dd"
engine_RawMutableMatrixOrNull engine_star__4(const struct RingElement * f,struct MutableMatrix * M){
  # line 187 "../../../../Macaulay2/d/engine.dd"
  
     try { return M->mult(f); }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 187 "../../../../Macaulay2/d/engine.dd"
  }
# line 190 "../../../../Macaulay2/d/engine.dd"
engine_RawMutableMatrixOrNull engine_star__5(struct MutableMatrix * M,const struct RingElement * f){
  # line 190 "../../../../Macaulay2/d/engine.dd"
  
     try { return M->mult(f); }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 190 "../../../../Macaulay2/d/engine.dd"
  }
# line 193 "../../../../Macaulay2/d/engine.dd"
engine_RawMatrixOrNull engine_star__6(const struct Matrix * M,const struct Matrix * N){
  # line 193 "../../../../Macaulay2/d/engine.dd"
  
     try { return M->mult(N, true); }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 193 "../../../../Macaulay2/d/engine.dd"
  }
# line 200 "../../../../Macaulay2/d/engine.dd"
engine_RawMutableMatrixOrNull engine_star__7(struct MutableMatrix * M,struct MutableMatrix * N){
  # line 200 "../../../../Macaulay2/d/engine.dd"
  
     try { return M->mult(N); }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 200 "../../../../Macaulay2/d/engine.dd"
  }
# line 212 "../../../../Macaulay2/d/engine.dd"
engine_RawMonomialIdealOrNull engine_plus__3(const struct MonomialIdeal * I,const struct MonomialIdeal * J){
  # line 212 "../../../../Macaulay2/d/engine.dd"
  
     if (I->get_ring() != J->get_ring()) {
	 ERROR("expected ideals in the same ring");
	 return 0; }
     MonomialIdeal *result = *I + *J;
     intern_monideal(result);
     return result;
     ;
  # line 212 "../../../../Macaulay2/d/engine.dd"
  }
# line 220 "../../../../Macaulay2/d/engine.dd"
engine_RawMonomialIdealOrNull engine_minus__6(const struct MonomialIdeal * I,const struct MonomialIdeal * J){
  # line 220 "../../../../Macaulay2/d/engine.dd"
  
     if (I->get_ring() != J->get_ring()) {
	 ERROR("expected ideals in the same ring");
	 return 0; }
     MonomialIdeal *result = *I - *J;
     intern_monideal(result);
     return result;
     ;
  # line 220 "../../../../Macaulay2/d/engine.dd"
  }
# line 228 "../../../../Macaulay2/d/engine.dd"
engine_RawMonomialIdealOrNull engine_star__8(const struct MonomialIdeal * I,const struct MonomialIdeal * J){
  # line 228 "../../../../Macaulay2/d/engine.dd"
  
     try { if (I->get_ring() != J->get_ring()) {
	       ERROR("expected ideals in the same ring");
	       return 0; }
	   MonomialIdeal *result = (*I) * (*J);
	   intern_monideal(result);
	   return result; }
     catch (const exc::engine_error& e) { ERROR(e.what()); return NULL; } ;
  # line 228 "../../../../Macaulay2/d/engine.dd"
  }
# line 236 "../../../../Macaulay2/d/engine.dd"
M2_string engine_tostring(const struct Monomial * a){
  # line 236 "../../../../Macaulay2/d/engine.dd"
  
     buffer o;
     try { a->text_out(o); }
     catch (const exc::engine_error& e) { o << "[unprintable monomial]"; }
     return o.to_string();
     ;
  # line 236 "../../../../Macaulay2/d/engine.dd"
  }
# line 242 "../../../../Macaulay2/d/engine.dd"
unsigned int engine_hash(const struct Monomial * a){
  # line 242 "../../../../Macaulay2/d/engine.dd"
  return a->hash();
  # line 242 "../../../../Macaulay2/d/engine.dd"
  }
# line 242 "../../../../Macaulay2/d/engine.dd"
static void engine__thread_prepare();
# line 242 "../../../../Macaulay2/d/engine.dd"
static void engine__final();
# line 242 "../../../../Macaulay2/d/engine.dd"
void engine__prepare(){
  # line 242 "../../../../Macaulay2/d/engine.dd"
  static struct FUNCTION_CELL this_final, this_thread_prepare;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  static int called_yet = 0;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  if (called_yet) return; else called_yet = 1;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  gmp__prepare();
  # line 242 "../../../../Macaulay2/d/engine.dd"
  this_thread_prepare.func = engine__thread_prepare;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  this_thread_prepare.next = thread_prepare_list;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  thread_prepare_list = &this_thread_prepare;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  this_final.func = engine__final;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  this_final.next = final_list;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  final_list = &this_final;
  # line 242 "../../../../Macaulay2/d/engine.dd"
  }
# line 242 "../../../../Macaulay2/d/engine.dd"
static void engine__thread_prepare(){
  # line 242 "../../../../Macaulay2/d/engine.dd"
  }
# line 242 "../../../../Macaulay2/d/engine.dd"
static void engine__final(){
  # line 242 "../../../../Macaulay2/d/engine.dd"
  }
